import java.net.*;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.text.SimpleDateFormat;
import java.util.*;

class Currency
{
	public String[] countryList = new String[31];
	public String[] markList = new String[31];
	public float[] currencyValues = new float[31];
	public String currencyDate;


	Currency()
	{
		setCurrencyValues();
	}

	//connect to nbj site and get each currency value
	void setCurrencyValues()
	{
		URLConnection conn;
		InputStreamReader in;
		BufferedReader data;
		String line,date,nbjurl;
		String[] lineDelimited;
		boolean urlpassed=false;
		int daysbefore=0;


		do
		{
			try
			{
				urlpassed=true;
				Calendar now = Calendar.getInstance();
				SimpleDateFormat formatter = new SimpleDateFormat("yyMMdd");
				now.add(Calendar.DATE, - daysbefore);
				date=formatter.format(now.getTime());
				currencyDate=date;
				nbjurl="http://www.nbs.yu/serbian/kursevi/ascii/Kl".concat(date).concat(".asc");


				URL nbj=new URL(nbjurl);
				conn=nbj.openConnection();
				conn.connect();

				in=new InputStreamReader(conn.getInputStream());
				data=new BufferedReader(in);

				int i=0;
				while((line=data.readLine())!=null)
				{
					lineDelimited=line.split(";");
					countryList[i]=lineDelimited[3];
					markList[i]=lineDelimited[4];
					currencyValues[i]=Float.parseFloat(lineDelimited[9]);
					i++;
				}
				countryList[i]="YUGOSLAVIA";
				markList[i]="DIN";
				currencyValues[i]=1f;


			}
			catch(IOException e)
			{
				daysbefore++;
				urlpassed = false;
			}
		}
		while(urlpassed == false);
	}
}


public class Converter extends JFrame implements ActionListener
{

	JLabel l1=new JLabel("Konvertujem:");

	JLabel l2=new JLabel("Valuta:");
	JLabel l3=new JLabel("u",JLabel.RIGHT);
	JTextField entry=new JTextField("iznos");
	JTextField total=new JTextField();
	JButton b1=new JButton("Konvertuj");
	JComboBox currencyFrom=new JComboBox();
	JComboBox currencyTo=new JComboBox();
	Currency curr=new Currency();


	Converter()
	{
		super("Converter");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		for(int i=0;i<curr.countryList.length;i++)
		{
			currencyFrom.addItem(""+curr.countryList[i]+" ("+curr.markList[i]+")" );
			currencyTo.addItem(""+curr.countryList[i]+" ("+curr.markList[i]+")" );
		}

		entry.setHorizontalAlignment(JTextField.RIGHT);
		total.setHorizontalAlignment(JTextField.RIGHT);
		b1.addActionListener(this);
		JPanel pane=new JPanel();
		GridLayout layout=new GridLayout(4,4,2,2);
		pane.setLayout(layout);
		pane.add(l1);
		pane.add(l2);
		pane.add(entry);
		pane.add(currencyFrom);
		pane.add(l3);
		pane.add(currencyTo);
		pane.add(b1);
		pane.add(total);

		setContentPane(pane);
		pack();
		setLocation(300,300);
		setVisible(true);
	}

	public void actionPerformed(ActionEvent evt)
	{
		Object source=evt.getSource();
		if(source == b1)
		 {
			 int indexFrom=currencyFrom.getSelectedIndex();
			 int indexTo=currencyTo.getSelectedIndex();

			 float currencyFrom=curr.currencyValues[indexFrom];
			 float currencyTo=curr.currencyValues[indexTo];

			 try
			 {
				 float entryValue=Float.parseFloat(entry.getText());
				 float totalValue=entryValue * (currencyFrom / currencyTo);
				 total.setText(Float.toString(totalValue));
			 }
			 catch(NumberFormatException e)
			 {
				 JOptionPane.showMessageDialog(null,"Uneta vrednost nije broj",
				 "Greska",JOptionPane.ERROR_MESSAGE);
				 total.setText("");
				 entry.setText("");
			 }
		 }
	 }


	public static void main(String arguments[])
	{
		Converter win=new Converter();
	}
}




